<?php
namespace Teknisa\PED\Controllers;

use Teknisa\PED\Controllers\TeknisaCrud;
use Doctrine\ORM\EntityManager;
use Teknisa\GER\Controllers\CrudController;
use Zeedhi\Framework\DataSource\ParameterBag;
use \Teknisa\GER\Libraries\PHPMailer;
use \Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO;

use Teknisa\GER\Services\CrudService;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request\Row;
use Teknisa\PED\Services\ped07000AgendaVendedorRegiaoService;

class ped07000AgendaVendedorRegiaoController extends TeknisaCrud {

    protected $dataSourceName = 'agendavendedor_regiaoped_cliente';
    protected $dataSourceNameToSave = '';
    protected $service; 
    protected $parameterBag;
    protected $entityManager;
    
    public function __construct($crudService, ParameterBag $parameterBag, EntityManager $entityManager, ped07000AgendaVendedorRegiaoService $service)
    {        
        $this->service = $service;
        $this->entityManager = $entityManager;
        $this->ped07000AgendaVendedorRegiaoService = $service;
        parent::__construct($crudService, $parameterBag);
    }
    
    public function saveCliente(Row $request, Response $response) {
        $this->dataSourceName = 'agendavendedor_regiaoped_cliente';
        $row  = $request->getRow();
    
        try {
            
            foreach($row['CDCLIENTES'] as $cliente) {
                $rowToSave = array();
                $rowToSave['CDCLIENTE'] = $cliente;
                // $rowToSave['NRORG'] = $row['NRORG'];
                // $rowToSave['CDCLIENTE'] = $row['CDCLIENTE'];
                $rowToSave['NRSEQAGEVEND'] = $row['NRSEQAGEVEND'];
                $rowToSave['CDVENDEDOR'] = $row['CDVENDEDOR'];
                $rowToSave['CDREGIAOPED'] = $row['CDREGIAOPED'];
                $rowToSave['DTAGEVENDREGIAO'] = $row['DTAGEVENDREGIAO'];
                $rowToSave['DSAGEVENDREGIAO'] = $row['DSAGEVENDREGIAO'];                                  
                $rowToSave['__is_new'] = $row['__is_new'];                                  
                
                $rowToSave['NRSEQAGEVEND'] = $this->service->geraNrSeqAgendaVendedor($row['__new_code_pk']);
                $dataSet = new DataSet($this->dataSourceName, array($rowToSave));
                $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
                // var_dump($requestSalvar);
                parent::save($requestSalvar, $response);
            }
            
        } catch (\Exception $e) {
            if(!(($response->getError()))) {
                $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
            }
        }
        
    }
    
    public function buscaCalendarColor(Row $request, Response $response) {
        $this->dataSourceName = 'agendavendedor_regiaoped_cliente';
        $row = $request->getRow();
        try {
            $x = $this->service->buscaCalendarColor($row[0]);
            $dataset = new DataSet('calendar_color', $x);
            $response->setDataSets(array($dataset));
        } catch (\Exception $e) {
            if(!(count($response->getError()))) {
                $response->setError(new Error("Error in data search. ". $e->getMessage(), 500));
            }
        }
        
    }

}